#ifndef MORPHER_H
#define MORPHER_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <time.h>
#include <unistd.h>
#include <boost/random/uniform_01.hpp>
#include <utility>

extern "C" {

#include "dream/dream.h"

}

#include "Packet.h"

#define MSG_MAX_LEN MAX_RAW_MSG_LEN
#define MAX_PKT_SIZE MAX_RAW_MSG_LEN
#define MAX_INTER_PKT_DELAY 1000 // this is in millisecond

#define MORPH_ARRAY_LEN MSG_MAX_LEN / MORPH_STEP

using namespace std;


enum mm_type {
  MP_NONE  = 0,                 // no morphing; fixed size and timing
  MP_TM,                        // traffic morphing
  MP_NAIVE,                     // naive morphing
  NUM_MP_METHODS
}; 

class Morpher
{

public:
  Morpher(int t) : type(t) { }  
  pair <size_t,size_t> get_next_time_len(size_t);
  void init(const char*, const char*, const char *, const char*);

private:
    double *time_dis, *size_dis, *tor_size_dis; 
	csc_t* morph_csc;
    int type; 
	void morph_init(const char * fn_matrix);
	size_t morph(size_t);
};


#endif


/*
typedef struct morpher_t
{
	int rseed;
	int ct[MORPH_ARRAY_LEN];
} morpher_t;
*/


//extern csc_t * morph_csc;

//morpher_t* morpher_create(int seed);
//void morpher_random_data(morpher_t *m, data_buf_t *buf);
//size_t inverse_CDF(double* , size_t , double );
//void trunk_alloc(char *data, char *trunk,uint16_t len_real, uint16_t *len_trunk);
